package sample;

public class Sample implements Comparable<Sample> {
    public static void main(String[] args) {
        Sample.staticMethod();
        //0: invokestatic  #2                  // Method staticMethod:()V

        Sample sample = new Sample();
        //7: invokespecial #4                  // Method "<init>":()V

        sample.instanceMethod();
        //12: invokevirtual #5                  // Method instanceMethod:()V

        compare(sample);
    }

    private static void compare(Comparable<Sample> aComparable) {
        aComparable.compareTo(new Sample());
        //8: invokeinterface #7,  2            // InterfaceMethod java/lang/Comparable.compareTo:(Ljava/lang/Object;)I
    }

    private void aPrivateMethod() {
        System.out.println("a private method called");
    }

    public void instanceMethod() {
        System.out.println("instance method called");
    }

    private static void staticMethod() {
        System.out.println("staitc method called");
    }

    @Override
    public int compareTo(Sample o) {
        return 0;
    }
}
