package sample;

import java.lang.invoke.MethodHandles;
import java.lang.invoke.MethodHandle;
import java.lang.invoke.MethodType;

public class Sample {
    public static void main(String[] args) throws Throwable {
        MethodHandles.Lookup lookup = MethodHandles.lookup();
        MethodHandle handle = lookup.findStatic(Sample.class, "aStaticMethod", MethodType.methodType(void.class, Double.TYPE));
        handle.invokeExact(2.0);

        //handle.invokeExact(2); //Exception, the type of the argument does not match exactly with the type expected.

        handle.invoke(2); //Will take care of conversion as appropriate.
    }

    public static void aStaticMethod(double input) {
        System.out.println("a static method called with " + input);
    }
}

