package sample;

public class Sample {
    public final void foo() {
        System.out.println("a final method called");
    }

    public static void main(String[] args) {
        Sample sample = new Sample();

        /*
            foo is a final method, it can't be overridden by a derived class.
            Yet, the compiler generates this call as invokevirtual and leaves it
            to the runtime to optimize the call at the JIT compilation time.

            Several other optimizations happen at runtime.
         */

        sample.foo();
        //9: invokevirtual #7                  // Method foo:()V

    }
}

