package sample;

import java.lang.reflect.Method;
import java.lang.invoke.MethodHandles;
import java.lang.invoke.MethodHandle;

public class Sample {
    public static void main(String[] args) throws Throwable {
        Method method = Sample.class.getMethod("aStaticMethod", Double.TYPE);
        MethodHandle handle = MethodHandles.lookup().unreflect(method);

        handle.invoke(2);
    }

    public static void aStaticMethod(double input) {
        System.out.println("a static method called with " + input);
    }
}

