package sample;

import java.lang.invoke.MethodHandle;
import java.lang.invoke.MethodHandles;
import java.lang.invoke.MethodType;

public class Sample {
    public static void main(String[] args) throws Throwable {
        MethodHandles.Lookup lookup = MethodHandles.lookup();
        MethodHandle handle = lookup.findVirtual(Sample.class, "doubleIt", MethodType.methodType(Double.TYPE, Integer.TYPE));
        MethodHandle handleToInstanceMethod = handle.bindTo(new Sample());

        System.out.println(handleToInstanceMethod.invoke(4));
    }

    public double doubleIt(int value) {
        return value * 2.0;
    }
}
